<template>
  <router-link
    :to="{
      name: 'SEARCH',
      query: {
        categoryOneOf: [props.category.key],
        contentType: 'EVENTS',
        distance: 'anywhere',
        sort: 'START_TIME_ASC',
      },
    }"
    class="block max-w-xs rounded-lg overflow-hidden bg-center bg-no-repeat bg-cover shadow-lg relative group"
  >
    <picture
      v-if="categoriesWithPictures.includes(props.category.key)"
      class="brightness-50"
    >
      <source
        :srcset="`/img/categories/${props.category.key.toLowerCase()}.jpg 2x, /img/categories/${props.category.key.toLowerCase()}.jpg`"
        media="(min-width: 1000px)"
      />
      <source
        :srcset="`/img/categories/${props.category.key.toLowerCase()}.jpg 2x, /img/categories/${props.category.key.toLowerCase()}-small.jpg`"
        media="(min-width: 300px)"
      />
      <img
        class="w-full h-36 w-36 md:h-52 md:w-52 object-cover"
        :src="`/img/categories/${props.category.key.toLowerCase()}.jpg`"
        :srcset="`/img/categories/${props.category.key.toLowerCase()}-small.jpg `"
        alt=""
      />
    </picture>
    <p
      v-else
      class="h-36 w-36 md:h-52 md:w-52 brightness-75"
      :class="randomGradient()"
    />
    <div class="px-3 py-1 absolute left-0 bottom-0">
      <h2
        class="group-hover:text-slate-200 font-semibold text-white tracking-tight text-xl mb-3"
      >
        {{ eventCategoryLabel(props.category.key) }}
      </h2>
    </div>
    <span
      v-if="withDetails"
      class="absolute z-10 inline-flex items-center px-3 py-1 text-xs font-semibold text-white bg-black rounded-full right-2 top-2"
    >
      {{
        $ngettext('One event', '%{count} events', props.category.doc_count, {
          count: props.category.doc_count.toString(),
        })
      }}
    </span>
  </router-link>
</template>
<script setup lang="ts">
  import { categoriesWithPictures, eventCategories } from '@/query/constants'
  import { randomGradient } from '@/shared/utils'
  import { useGettext } from 'vue3-gettext'
  import { CategoryStatsModel } from '../../../shared/stats.model'

  const props = withDefaults(
    defineProps<{ category: CategoryStatsModel; withDetails?: boolean }>(),
    {
      withDetails: false,
    }
  )

  const { $gettext } = useGettext()

  const eventCategoryLabel = (categoryId: string): string | undefined => {
    return eventCategories($gettext).find(({ id }) => id === categoryId)?.label
  }
</script>
